=== debian/changelog ===
vcmi (1.7.2+dfsg-1) unstable; urgency=medium

  * New upstream release, merging
    0004-use-Mix_Music-from-SDL_Mixer-directly.patch and supporting
    building without boost_system. Closes: #1127292.

 -- Stephen Kitt <skitt@debian.org>  Mon, 23 Feb 2026 12:06:30 +0100
